"""file: exp.py -- correction td3, exercise about quick exponentiation

"""

import random

# most naive way to define exponentiation: a**n is a*a**(n-1)

def power_naive(a,n):
  """a is a number, n an integer.

  power_naive(a,n) returns a to the power n.

  """
  if n == 0: return 1
  else: return a*power_naive(a,n-1)

# using quick exponentiation
def quick_pow(a,n):
  """a is a number, n an integer.

  quick_pow(a,n) returns a to the power n.

  """
  if n == 0: return 1
  else:
    half = quick_pow(a,n//2)
    return half*half*(a if n%2 == 1 else 1)

## testing
for (x,y) in [(random.randrange(100,1000), random.randrange(1,20)) for i in range(20)]:
  print x, "to the power", y, "=", power_naive(x,y)
  print x, "to the power", y, "=", quick_pow(x,y)
  print
